%if 0%{?fedora} <= 22
%global _hardened_build 1
%endif

%if 0%{?rhel} && 0%{?rhel} <= 6
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}

%global python2_version 2.6
%global with_python2 1
%global py2dir %{_builddir}/python2-%{name}-%{version}-%{release}
%else
%global with_python3 1
%global with_python2 1
%endif

%if 0%{?fedora}
%global with_python2 1
%global py2dir %{_builddir}/python2-%{name}-%{version}-%{release}
%global python3_pkgversion 3

%global with_python3 1
%endif

## Make python?_shortver macros
%{!?python2_shortver: %global python2_shortver %(%{__python2} -c 'import sys; print(str(sys.version_info.major) + "." + str(sys.version_info.minor))')}
%{!?python3_shortver: %global python3_shortver %(%{__python3} -c 'import sys; print(str(sys.version_info.major) + "." + str(sys.version_info.minor))')}

## The RPM macro for the linker flags does not exist on EPEL
%if 0%{?epel} < 7
%{!?__global_ldflags: %global __global_ldflags -Wl,-z,relro}
%endif

%global  checkout   160231bdd7887316b544412e8b97bcdd86ac25a4
%global  date       20160108

Name:    telegram-cli
Version: 1.3.3
Release: 0.5.%{date}git%(echo %{checkout} | cut -c-6)%{?dist}
Summary: Linux Command-line interface for Telegram
License: GPLv2+ and LGPLv2+
URL:     https://github.com/vysheng/tg
## Source archive made by using following commands
## git clone --recursive https://github.com/vysheng/tg
## rm -rf tg/.git
## tar -cvzf tg-%%{checkout}.tar.gz tg
Source0: tg-%{checkout}.tar.gz

## New updated manpage file
Source1: %{name}.8

## See bz#1138804
## Upstream issue on https://github.com/vysheng/tg/issues/239
ExcludeArch: ppc64 s390 s390x

BuildRequires: lua-devel, openssl-devel, libevent-devel
BuildRequires: libconfig-devel, readline-devel, jansson-devel
Requires: %{name}-data = %{version}-%{release}

%description
Telegram is an Open Source instant messaging platform for mobile and
desktop focused on privacy. 
This is a Linux Command-line interface for Telegram.

%package data
Summary: Telegram-cli licenses and config files
BuildArch: noarch

%description data
Telegram is an Open Source instant messaging platform for mobile and
desktop focused on privacy. 
This is a Linux Command-line interface for Telegram.

%if 0%{?with_python2}
%package -n python2-telegram-cli
Summary: Telegram-cli Python2 binding
%{?python_provide:%python_provide python2-%{name}}
BuildRequires: python2-devel
Requires: %{name}-data = %{version}-%{release}

%description -n python2-telegram-cli
Telegram is an Open Source instant messaging platform for mobile and
desktop focused on privacy. 
This is a Linux Command-line interface for Telegram.
%endif # with_python2

%if 0%{?with_python3}
%package -n python%{python3_pkgversion}-telegram-cli
Summary: Telegram-cli Python3 binding
%{?python_provide:%python_provide python3-%{name}}
BuildRequires: python%{python3_pkgversion}-devel
BuildRequires: python3-pkgversion-macros
Requires: %{name}-data = %{version}-%{release}

%description -n python%{python3_pkgversion}-telegram-cli
Telegram is an Open Source instant messaging platform for mobile and
desktop focused on privacy. 
This is a Linux Command-line interface for Telegram.
%endif # with_python3

%prep
%setup -qc

%if 0%{?with_python2}
cp -a tg python2
%endif # with_python2

%if 0%{?with_python3}
cp -a python2 python3
%endif # with_python3

%build
pushd tg
%configure --enable-libconfig --enable-liblua --enable-extf \
 --with-zlib=%{_prefix} --with-openssl=%{_prefix} --with-progname=telegram-cli \
 --enable-json --enable-extf --disable-valgrind --disable-python

make %{?_smp_mflags} CFLAGS="%{optflags} -Wl,-z,relro -Wl,-z,now" LDFLAGS="%{__global_ldflags} -Wl,-z,now -L%{_libdir}" CPPFLAGS=" -I%{_includedir}"
popd

%if 0%{?with_python2}
pushd python2
sed -i \
 's|for python in python3.5 python3.4 python3.3 python3.2 python3.1 python3 python2.7 python2.6 python2 python; do|for python in python%{python2_version} python2.6 python2; do|g' \
./ax_python.m4
sed -i \
 's|for python in python3.5 python3.4 python3.3 python3.2 python3.1 python3 python2.7 python2.6 python2 python; do|for python in python%{python2_version} python2.6 python2; do|g' \
./configure
%configure --enable-libconfig --enable-liblua --enable-extf \
 --with-zlib=%{_prefix} --with-openssl=%{_prefix} --with-progname=telegram-cli \
 --enable-json --enable-extf --disable-valgrind --enable-python

make %{?_smp_mflags} CFLAGS="%{optflags} -Wl,-z,relro -Wl,-z,now" LDFLAGS="%{__global_ldflags} -Wl,-z,now"
popd
%endif

%if 0%{?with_python3}
pushd python3
sed -i \
 's|for python in python3.5 python3.4 python3.3 python3.2 python3.1 python3 python2.7 python2.6 python2 python; do|for python in python%{python3_version}m python3; do|g' ./ax_python.m4
sed -i \
 's|for python in python3.5 python3.4 python3.3 python3.2 python3.1 python3 python2.7 python2.6 python2 python; do|for python in python%{python3_version}m python3; do|g' ./configure
%configure --enable-libconfig --enable-liblua --enable-extf \
 --with-zlib=%{_prefix} --with-openssl=%{_prefix} --with-progname=telegram-cli \
 --enable-json --enable-extf --disable-valgrind --enable-python

make %{?_smp_mflags} CFLAGS="%{optflags} -Wl,-z,relro -Wl,-z,now" LDFLAGS="%{__global_ldflags} -Wl,-z,now"
popd
%endif


%install
##Manual installation
#make DESTDIR=%%{buildroot} install
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_sysconfdir}/telegram-cli
mkdir -p %{buildroot}%{_mandir}/man8

pushd tg
install -p -m 0755 bin/telegram-cli %{buildroot}%{_bindir}
install -p -m 0755 bin/tl-parser %{buildroot}%{_bindir}
install -p -m 0755 bin/generate %{buildroot}%{_bindir}
popd

%if 0%{?with_python2}
pushd python2
mv bin/telegram-cli %{buildroot}%{_bindir}/python%{python2_version}-telegram-cli
mv bin/tl-parser %{buildroot}%{_bindir}/python%{python2_version}-tl-parser
mv bin/generate %{buildroot}%{_bindir}/python%{python2_version}-generate

for i in telegram-cli-2 telegram-cli-%{?python2_shortver}; do
  touch $i
  install -p $i %{buildroot}%{_bindir}
  ln -fs %{_bindir}/python%{python2_version}-telegram-cli %{buildroot}%{_bindir}/$i
done
for i in tl-parser-2 tl-parser-%{?python2_shortver}; do
  touch $i
  install -p $i %{buildroot}%{_bindir}
  ln -fs %{_bindir}/python%{python2_version}-tl-parser %{buildroot}%{_bindir}/$i
done
for i in generate-2 generate-%{?python2_shortver}; do
  touch $i
  install -p $i %{buildroot}%{_bindir}
  ln -fs %{_bindir}/python%{python2_version}-generate %{buildroot}%{_bindir}/$i
done
popd
%endif

%if 0%{?with_python3}
pushd python3
mv bin/telegram-cli %{buildroot}%{_bindir}/python%{python3_version}-telegram-cli
mv bin/tl-parser %{buildroot}%{_bindir}/python%{python3_version}-tl-parser
mv bin/generate %{buildroot}%{_bindir}/python%{python3_version}-generate

for i in telegram-cli-3 telegram-cli-%{?python3_shortver}; do
  touch $i
  install -p $i %{buildroot}%{_bindir}
  ln -sf %{_bindir}/python%{python3_version}-telegram-cli %{buildroot}%{_bindir}/$i
done
for i in tl-parser-3 tl-parser-%{?python3_shortver}; do
  touch $i
  install -p $i %{buildroot}%{_bindir}
  ln -sf %{_bindir}/python%{python3_version}-tl-parser %{buildroot}%{_bindir}/$i
done
for i in generate-3 generate-%{?python3_shortver}; do
  touch $i
  install -p $i %{buildroot}%{_bindir}
  ln -sf %{_bindir}/python%{python3_version}-generate %{buildroot}%{_bindir}/$i
done
popd
%endif

install -p -m 0644 tg/server.pub %{buildroot}%{_sysconfdir}/telegram-cli

##Unfortunately, manpage file from upstream is still outdated
##Using a custom one
install -p -m 0644 %{SOURCE1} %{buildroot}%{_mandir}/man8

%files
%{_bindir}/telegram-cli
%{_bindir}/tl-parser
%{_bindir}/generate

%files data
%{!?_licensedir:%global license %doc}
%doc tg/README.md tg/README-LUA tg/CHANGELOG
%license tg/LICENSE
%dir %{_sysconfdir}/telegram-cli
%config(noreplace) %{_sysconfdir}/telegram-cli/server.pub
%{_mandir}/man8/%{name}.8*

%if 0%{?with_python2}
%files -n python2-telegram-cli
%doc python2/README-PY.md
%{_bindir}/python%{python2_version}-*
%{_bindir}/generate-2
%{_bindir}/generate-%{?python2_shortver}
%{_bindir}/telegram-cli-2
%{_bindir}/telegram-cli-%{?python2_shortver}
%{_bindir}/tl-parser-2
%{_bindir}/tl-parser-%{?python2_shortver}
%endif

%if 0%{?with_python3}
%files -n python%{python3_pkgversion}-telegram-cli
%doc python3/README-PY.md
%{_bindir}/python%{python3_version}-*
%{_bindir}/generate-3
%{_bindir}/generate-%{?python3_shortver}
%{_bindir}/telegram-cli-3
%{_bindir}/telegram-cli-%{?python3_shortver}
%{_bindir}/tl-parser-3
%{_bindir}/tl-parser-%{?python3_shortver}
%endif

%changelog
* Fri Feb 05 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1.3.3-0.5.20160108git160231
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Fri Jan 29 2016 Antonio Trande <sagitterATfedoraproject.org> - 1.3.3-0.4.20160108git160231
- Fixed Python3 package version on EPEL

* Fri Jan 29 2016 Antonio Trande <sagitterATfedoraproject.org> - 1.3.3-0.3.20160108git160231
- Renamed Python2 package
- Update to commit #160231

* Wed Dec 09 2015 Antonio Trande <sagitter@fedoraproject.org> - 1.3.3-0.2.20151014git3a898a
- SPEC file adapted to recent guidelines for Python

* Thu Nov 19 2015 Antonio Trande <sagitterATfedoraproject.org> 1.3.3-0.1.20151014git3a898a
- Update to commit #3a898a (1.3.3 pre-release)
- Added a custom manpage file updated

* Tue Nov 10 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3.1-8.20150730git2052f4
- Rebuilt for https://fedoraproject.org/wiki/Changes/python3.5

* Thu Nov 05 2015 Antonio Trande <sagitterATfedoraproject.org> 1.3.1-7.20150730git2052f4
- Hardened builds on <F23

* Thu Sep 24 2015 Antonio Trande <sagitterATfedoraproject.org> 1.3.1-6.20150730git2052f4
- Update to commit #2052f4
- Added python_provide macro

* Thu Jul 30 2015 Antonio Trande <sagitterATfedoraproject.org> 1.3.1-5.20150710gitcf6cb9
- Fixed Python* symlinks

* Wed Jul 29 2015 Antonio Trande <sagitterATfedoraproject.org> 1.3.1-4.20150710gitcf6cb9
- Packaging of Python bindings activated

* Fri Jul 17 2015 Antonio Trande <sagitterATfedoraproject.org> 1.3.1-3.20150710gitcf6cb9
- Update to commit #cf6cb9
- Packaging of Python bindings prearranged but inactive

* Fri Jun 19 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3.1-2.20150515git5935c9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Fri May 15 2015 Antonio Trande <sagitterATfedoraproject.org> 1.3.1-1.20150114gitd96750
- Update to 1.3.1
- Added jansson-devel BR
- This code can work only in little-endian systems

* Thu Feb 05 2015 Antonio Trande <sagitterATfedoraproject.org> 1.2.0-1.20150114gitd96750
- Version updated
- tg-server.pub key excluded

* Sat Jan 17 2015 Antonio Trande <sagitterATfedoraproject.org> 1.0.6-0.4.20150114gitd96750
- Packaged tg-server.pub directory and file

* Sat Jan 17 2015 Antonio Trande <sagitterATfedoraproject.org> 1.0.6-0.3.20150114gitd96750
- Packaged manpage
- Changed server.pub localization

* Fri Jan 16 2015 Antonio Trande <sagitterATfedoraproject.org> 1.0.6-0.2.20150114gitd96750
- Update to the commit d96750 (pre-release 1.0.6)
- Used new macro %%license

* Sat Dec 06 2014 Antonio Trande <sagitterATfedoraproject.org> 1.0.6-0.1.20141204git717b01
- Update to the commit 717b01 (pre-release 1.0.6)

* Wed Sep 24 2014 Antonio Trande <sagitterATfedoraproject.org> 1.0.5-1 
- Update to 1.0.5

* Mon Sep 08 2014 Antonio Trande <sagitterATfedoraproject.org> 1.0.2-1.20140908git8c2069
- Add support of libevent 1.4.* (on EPEL) 
- Update to 1.0.2

* Fri Sep 05 2014 Antonio Trande <sagitterATfedoraproject.org> 1.0.1-3.20140831git30ad29
- ExcludeArch ppc ppc64
- Defined rhel macro for libevent headers

* Mon Sep 01 2014 Antonio Trande <sagitterATfedoraproject.org> 1.0.1-2.20140831git30ad29
- Added libevent BR

* Mon Sep 01 2014 Antonio Trande <sagitterATfedoraproject.org> 1.0.1-1.20140831git30ad29
- Release 1.0.1 (commit 30ad29)
- Binary file renamed telegram-cli
- Removed %%{?_smp_mflags} macro
- Added license LGPLv2+

* Mon Aug 18 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.7.20140321git1dad2e
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.6.20140321git1dad2e
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Wed Apr 23 2014 Antonio Trande <sagitterATfedoraproject.org> 0-0.5.20140321git1dad2e
- New commit (1dad2e)

* Wed Mar 19 2014 Antonio Trande <sagitterATfedoraproject.org> 0-0.4.20140316git90f627
- New commit (90f627)

* Sat Mar 15 2014 Antonio Trande <sagitterATfedoraproject.org> 0-0.3.20140312git046b8f
- New commit (046b8f)
- Defined a 'date' macro
- Added '--with-progname=' option 

* Sat Mar 08 2014 Antonio Trande <sagitterATfedoraproject.org> 0-0.2.20140307git8b78b6
- Package renamed to telegram-cli 

* Fri Mar 07 2014 Antonio Trande <sagitterATfedoraproject.org> 0-0.1.20140307git8b78b6
- Initial package
